/* ***********************************************************
 * This file was automatically generated on 2019-09-24.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import com.tinkerforge.Helper;

/**
 * 3.3cm (1.3") OLED display with 128x64 pixels
 */
public class BrickletOLED128x64 extends Device {
	public final static int DEVICE_IDENTIFIER = 263;
	public final static String DEVICE_DISPLAY_NAME = "OLED 128x64 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "oled128x64", DEVICE_IDENTIFIER, BrickletOLED128x64.class);

	public final static byte FUNCTION_WRITE = (byte)1;
	public final static byte FUNCTION_NEW_WINDOW = (byte)2;
	public final static byte FUNCTION_CLEAR_DISPLAY = (byte)3;
	public final static byte FUNCTION_SET_DISPLAY_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_DISPLAY_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_WRITE_LINE = (byte)6;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;



	public class DisplayConfiguration {
		public short contrast;
		public boolean invert;

		public String toString() {
			return "[" + "contrast = " + contrast + ", " + "invert = " + invert + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletOLED128x64(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_NEW_WINDOW)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_CLEAR_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DISPLAY_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Appends 64 byte of data to the window as set by {@link BrickletOLED128x64#newWindow(short, short, short, short)}.
	 * 
	 * Each row has a height of 8 pixels which corresponds to one byte of data.
	 * 
	 * Example: if you call {@link BrickletOLED128x64#newWindow(short, short, short, short)} with column from 0 to 127 and row
	 * from 0 to 7 (the whole display) each call of {@link BrickletOLED128x64#write(short[])} (red arrow) will
	 * write half of a row.
	 * 
	 * .. image:: /Images/Bricklets/bricklet_oled_128x64_display.png
	 *    :scale: 100 %
	 *    :alt: Display pixel order
	 *    :align: center
	 *    :target: ../../_images/Bricklets/bricklet_oled_128x64_display.png
	 * 
	 * The LSB (D0) of each data byte is at the top and the MSB (D7) is at the
	 * bottom of the row.
	 * 
	 * The next call of {@link BrickletOLED128x64#write(short[])} will write the second half of the row
	 * and the next two the second row and so on. To fill the whole display
	 * you need to call {@link BrickletOLED128x64#write(short[])} 16 times.
	 */
	public void write(short[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Sets the window in which you can write with {@link BrickletOLED128x64#write(short[])}. One row
	 * has a height of 8 pixels.
	 * 
	 * The columns have a range of 0 to 127 and the rows have a range of 0 to 7.
	 */
	public void newWindow(short columnFrom, short columnTo, short rowFrom, short rowTo) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_NEW_WINDOW, this);

		bb.put((byte)columnFrom);
		bb.put((byte)columnTo);
		bb.put((byte)rowFrom);
		bb.put((byte)rowTo);

		sendRequest(bb.array());
	}

	/**
	 * Clears the current content of the window as set by {@link BrickletOLED128x64#newWindow(short, short, short, short)}.
	 */
	public void clearDisplay() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CLEAR_DISPLAY, this);


		sendRequest(bb.array());
	}

	/**
	 * Sets the configuration of the display.
	 * 
	 * You can set a contrast value from 0 to 255 and you can invert the color
	 * (black/white) of the display.
	 * 
	 * The default values are contrast 143 and inverting off.
	 */
	public void setDisplayConfiguration(short contrast, boolean invert) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_DISPLAY_CONFIGURATION, this);

		bb.put((byte)contrast);
		bb.put((byte)(invert ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletOLED128x64#setDisplayConfiguration(short, boolean)}.
	 */
	public DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISPLAY_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DisplayConfiguration obj = new DisplayConfiguration();
		obj.contrast = IPConnection.unsignedByte(bb.get());
		obj.invert = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Writes text to a specific line (0 to 7) with a specific position
	 * (0 to 25). The text can have a maximum of 26 characters.
	 * 
	 * For example: (1, 10, "Hello") will write *Hello* in the middle of the
	 * second line of the display.
	 * 
	 * You can draw to the display with {@link BrickletOLED128x64#write(short[])} and then add text to it
	 * afterwards.
	 * 
	 * The display uses a special 5x7 pixel charset. You can view the characters
	 * of the charset in Brick Viewer.
	 */
	public void writeLine(short line, short position, String text) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)36, FUNCTION_WRITE_LINE, this);

		bb.put((byte)line);
		bb.put((byte)position);
		for (int i = 0; i < 26; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletOLED128x64.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletOLED128x64.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED128x64Config cfg = (BrickletOLED128x64Config) config.as(BrickletOLED128x64Config.class);
        
        this.setDisplayConfiguration(cfg.contrast.shortValue(), cfg.invert);
		{
		BrickletOLED128x64TextConfig channelCfg = getChannelConfigFn.apply("OLED128x64Text").as(BrickletOLED128x64TextConfig.class);
		
		}
		{
		BrickletOLED128x64ClearDisplayConfig channelCfg = getChannelConfigFn.apply("OLED128x64ClearDisplay").as(BrickletOLED128x64ClearDisplayConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletOLED128x64Config cfg = (BrickletOLED128x64Config) config.as(BrickletOLED128x64Config.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletOLED128x64Config cfg = (BrickletOLED128x64Config) config.as(BrickletOLED128x64Config.class);
        List<String> result = new ArrayList<String>();
        result.add("OLED128x64Text");
		result.add("OLED128x64ClearDisplay");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "OLED128x64Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "OLED128x64Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:OLED128x64Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "OLED128x64ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "OLED128x64ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:OLED128x64ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge OLED 128x64 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("3.3cm (1.3\") OLED display with 128x64 pixels").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("OLED128x64Text", new ChannelTypeUID("tinkerforge", "OLED128x64Text")).build(), new ChannelDefinitionBuilder("OLED128x64ClearDisplay", new ChannelTypeUID("tinkerforge", "OLED128x64ClearDisplay")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:oled128x64":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("contrast", Type.INTEGER).withDefault("143").withDescription("Sets the contrast of the display (0-255).").withLabel("Contrast").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("invert", Type.BOOLEAN).withDefault("false").withDescription("Inverts the color (black/white) of the display.").withLabel("Invert").build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:OLED128x64Text":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:OLED128x64ClearDisplay":
                return new ConfigDescription(uri, Arrays.asList());
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED128x64Config cfg = (BrickletOLED128x64Config) config.as(BrickletOLED128x64Config.class);
        switch(value) {
            case "OLED128x64Text":
               return;
            case "OLED128x64ClearDisplay":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletOLED128x64Config cfg = (BrickletOLED128x64Config) config.as(BrickletOLED128x64Config.class);
        switch(channel) {
            case "OLED128x64Text":
                if (command instanceof StringType) {
                    BrickletOLED128x64TextConfig channelCfg = channelConfig.as(BrickletOLED128x64TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "OLED128x64ClearDisplay":
                if (command instanceof StringType) {
                    BrickletOLED128x64ClearDisplayConfig channelCfg = channelConfig.as(BrickletOLED128x64ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    
}
