/* ***********************************************************
 * This file was automatically generated on 2019-09-24.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * Four 7-segment displays with switchable dots
 */
public class BrickletSegmentDisplay4x7V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2137;
	public final static String DEVICE_DISPLAY_NAME = "Segment Display 4x7 Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "segmentdisplay4x7v2", DEVICE_IDENTIFIER, BrickletSegmentDisplay4x7V2.class);

	public final static byte FUNCTION_SET_SEGMENTS = (byte)1;
	public final static byte FUNCTION_GET_SEGMENTS = (byte)2;
	public final static byte FUNCTION_SET_BRIGHTNESS = (byte)3;
	public final static byte FUNCTION_GET_BRIGHTNESS = (byte)4;
	public final static byte FUNCTION_SET_NUMERIC_VALUE = (byte)5;
	public final static byte FUNCTION_SET_SELECTED_SEGMENT = (byte)6;
	public final static byte FUNCTION_GET_SELECTED_SEGMENT = (byte)7;
	public final static byte FUNCTION_START_COUNTER = (byte)8;
	public final static byte FUNCTION_GET_COUNTER_VALUE = (byte)9;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COUNTER_FINISHED = 10;

	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<CounterFinishedListener> listenerCounterFinished = new CopyOnWriteArrayList<CounterFinishedListener>();

	public class Segments {
		public boolean[] digit0 = new boolean[8];
		public boolean[] digit1 = new boolean[8];
		public boolean[] digit2 = new boolean[8];
		public boolean[] digit3 = new boolean[8];
		public boolean[] colon = new boolean[2];
		public boolean tick;

		public String toString() {
			return "[" + "digit0 = " + Arrays.toString(digit0) + ", " + "digit1 = " + Arrays.toString(digit1) + ", " + "digit2 = " + Arrays.toString(digit2) + ", " + "digit3 = " + Arrays.toString(digit3) + ", " + "colon = " + Arrays.toString(colon) + ", " + "tick = " + tick + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered when the counter (see {@link BrickletSegmentDisplay4x7V2#startCounter(int, int, int, long)}) is
	 * finished.
	 */
	public interface CounterFinishedListener extends DeviceListener {
		public void counterFinished();
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletSegmentDisplay4x7V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SEGMENTS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SEGMENTS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BRIGHTNESS)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BRIGHTNESS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_NUMERIC_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_SEGMENT)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SELECTED_SEGMENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_START_COUNTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COUNTER_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COUNTER_FINISHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (CounterFinishedListener listener: listenerCounterFinished) {
					listener.counterFinished();
				}
			}
		};
	}

	/**
	 * Sets the segments of the Segment Display 4x7 Bricklet 2.0 segment-by-segment.
	 * 
	 * The data is split into the four digits, two colon dots and the tick mark.
	 * 
	 * The indices of the segments in the digit and colon parameters are as follows:
	 * 
	 * .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_segment_index.png
	 *    :scale: 100 %
	 *    :alt: Indices of segments
	 *    :align: center
	 */
	public void setSegments(boolean[] digit0, boolean[] digit1, boolean[] digit2, boolean[] digit3, boolean[] colon, boolean tick) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_SEGMENTS, this);


		byte[] digit0Bits = new byte[1];
		Arrays.fill(digit0Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit0[i]) {
				digit0Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit0Bits[i]);
		}

		byte[] digit1Bits = new byte[1];
		Arrays.fill(digit1Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit1[i]) {
				digit1Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit1Bits[i]);
		}

		byte[] digit2Bits = new byte[1];
		Arrays.fill(digit2Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit2[i]) {
				digit2Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit2Bits[i]);
		}

		byte[] digit3Bits = new byte[1];
		Arrays.fill(digit3Bits, (byte)0);

		for (int i = 0; i < 8; i++) {
			if (digit3[i]) {
				digit3Bits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(digit3Bits[i]);
		}

		byte[] colonBits = new byte[1];
		Arrays.fill(colonBits, (byte)0);

		for (int i = 0; i < 2; i++) {
			if (colon[i]) {
				colonBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(colonBits[i]);
		}
		bb.put((byte)(tick ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the segment data as set by {@link BrickletSegmentDisplay4x7V2#setSegments(boolean[], boolean[], boolean[], boolean[], boolean[], boolean)}.
	 */
	public Segments getSegments() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SEGMENTS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Segments obj = new Segments();
		byte[] digit0Bits = new byte[1];
		bb.get(digit0Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit0[i] = (digit0Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit1Bits = new byte[1];
		bb.get(digit1Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit1[i] = (digit1Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit2Bits = new byte[1];
		bb.get(digit2Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit2[i] = (digit2Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] digit3Bits = new byte[1];
		bb.get(digit3Bits);
		for (int i = 0; i < 8; i++) {
			obj.digit3[i] = (digit3Bits[i / 8] & (1 << (i % 8))) != 0;
		}

		byte[] colonBits = new byte[1];
		bb.get(colonBits);
		for (int i = 0; i < 2; i++) {
			obj.colon[i] = (colonBits[i / 8] & (1 << (i % 8))) != 0;
		}

		obj.tick = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The brightness can be set between 0 (dark) and 7 (bright).
	 * 
	 * The default value is 7.
	 */
	public void setBrightness(int brightness) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BRIGHTNESS, this);

		bb.put((byte)brightness);

		sendRequest(bb.array());
	}

	/**
	 * Returns the brightness as set by {@link BrickletSegmentDisplay4x7V2#setBrightness(int)}.
	 */
	public int getBrightness() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BRIGHTNESS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int brightness = IPConnection.unsignedByte(bb.get());

		return brightness;
	}

	/**
	 * Sets a numeric value for each of the digits. The values can be between
	 * -2 and 15. They represent:
	 * 
	 * * -2: minus sign
	 * * -1: blank
	 * * 0-9: 0-9
	 * * 10: A
	 * * 11: b
	 * * 12: C
	 * * 13: d
	 * * 14: E
	 * * 15: F
	 * 
	 * Example: A call with [-2, -1, 4, 2] will result in a display of "- 42".
	 */
	public void setNumericValue(int[] value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_NUMERIC_VALUE, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)value[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Turns one specified segment on or off.
	 * 
	 * The indices of the segments are as follows:
	 * 
	 * .. image:: /Images/Bricklets/bricklet_segment_display_4x7_v2_selected_segment_index.png
	 *    :scale: 100 %
	 *    :alt: Indices of selected segments
	 *    :align: center
	 */
	public void setSelectedSegment(int segment, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_SEGMENT, this);

		bb.put((byte)segment);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the value of a single segment.
	 */
	public boolean getSelectedSegment(int segment) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_SELECTED_SEGMENT, this);

		bb.put((byte)segment);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean value = (bb.get()) != 0;

		return value;
	}

	/**
	 * Starts a counter with the *from* value that counts to the *to*
	 * value with the each step incremented by *increment*.
	 * The *length* of the increment is given in ms.
	 * 
	 * Example: If you set *from* to 0, *to* to 100, *increment* to 1 and
	 * *length* to 1000, a counter that goes from 0 to 100 with one second
	 * pause between each increment will be started.
	 * 
	 * The maximum values for *from*, *to* and *increment* is 9999,
	 * the minimum value is -999.
	 * 
	 * Using a negative *increment* allows to count backwards.
	 * 
	 * You can stop the counter at every time by calling {@link BrickletSegmentDisplay4x7V2#setSegments(boolean[], boolean[], boolean[], boolean[], boolean[], boolean)}
	 * or {@link BrickletSegmentDisplay4x7V2#setNumericValue(int[])}.
	 */
	public void startCounter(int valueFrom, int valueTo, int increment, long length) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_START_COUNTER, this);

		bb.putShort((short)valueFrom);
		bb.putShort((short)valueTo);
		bb.putShort((short)increment);
		bb.putInt((int)length);

		sendRequest(bb.array());
	}

	/**
	 * Returns the counter value that is currently shown on the display.
	 * 
	 * If there is no counter running a 0 will be returned.
	 */
	public int getCounterValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COUNTER_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int value = IPConnection.unsignedShort(bb.getShort());

		return value;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletSegmentDisplay4x7V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletSegmentDisplay4x7V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletSegmentDisplay4x7V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletSegmentDisplay4x7V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a CounterFinished listener.
	 */
	public void addCounterFinishedListener(CounterFinishedListener listener) {
		listenerCounterFinished.add(listener);
	}

	/**
	 * Removes a CounterFinished listener.
	 */
	public void removeCounterFinishedListener(CounterFinishedListener listener) {
		listenerCounterFinished.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletSegmentDisplay4x7V2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletSegmentDisplay4x7V2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletSegmentDisplay4x7V2Config cfg = (BrickletSegmentDisplay4x7V2Config) config.as(BrickletSegmentDisplay4x7V2Config.class);
        
        
		{
		BrickletSegmentDisplay4x7V2BrightnessConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2Brightness").as(BrickletSegmentDisplay4x7V2BrightnessConfig.class);
		
		}
		{
		BrickletSegmentDisplay4x7V2ColonUpperConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2ColonUpper").as(BrickletSegmentDisplay4x7V2ColonUpperConfig.class);
		
		}
		{
		BrickletSegmentDisplay4x7V2ColonLowerConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2ColonLower").as(BrickletSegmentDisplay4x7V2ColonLowerConfig.class);
		
		}
		{
		BrickletSegmentDisplay4x7V2TickConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2Tick").as(BrickletSegmentDisplay4x7V2TickConfig.class);
		
		}
		{
		BrickletSegmentDisplay4x7V2SegmentsConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2Segments").as(BrickletSegmentDisplay4x7V2SegmentsConfig.class);
		
		}
		{
		BrickletSegmentDisplay4x7V2TextConfig channelCfg = getChannelConfigFn.apply("SegmentDisplay4x7V2Text").as(BrickletSegmentDisplay4x7V2TextConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletSegmentDisplay4x7V2Config cfg = (BrickletSegmentDisplay4x7V2Config) config.as(BrickletSegmentDisplay4x7V2Config.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletSegmentDisplay4x7V2Config cfg = (BrickletSegmentDisplay4x7V2Config) config.as(BrickletSegmentDisplay4x7V2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("SegmentDisplay4x7V2Brightness");
		result.add("SegmentDisplay4x7V2ColonUpper");
		result.add("SegmentDisplay4x7V2ColonLower");
		result.add("SegmentDisplay4x7V2Tick");
		result.add("SegmentDisplay4x7V2Segments");
		result.add("SegmentDisplay4x7V2Text");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "SegmentDisplay4x7V2Brightness":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Brightness"), "Brightness", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2Brightness")).withDescription("The brightness can be set between 0 (dark) and 7 (bright).")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(7)).withPattern("%d").withReadOnly(false).withOptions(Arrays.asList(new StateOption("0", "0"), new StateOption("1", "1"), new StateOption("2", "2"), new StateOption("3", "3"), new StateOption("4", "4"), new StateOption("5", "5"), new StateOption("6", "6"), new StateOption("7", "7"))).build().toStateDescription()).build();
            case "SegmentDisplay4x7V2Segments":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Segments"), "Segments", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2Segments")).withDescription("The seven segment display can be set with bitmaps. Every bit controls one segment as shown <a href=https://www.tinkerforge.com/en/doc/_images/bricklet_segment_display_4x7_bit_order.png>here</a>. The channel accepts an integer, that is split into 4 bytes, controlling one segment each. For example 1717263183, which is 0x665b5b4f in hex will be split into 0x66 for the first segment, 0x5b for the second, 0x5b for the third and 0x4f for the fourth.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").build().toStateDescription()).build();
            case "SegmentDisplay4x7V2ColonUpper":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2ColonUpper"), "Show Upper Colon Dot", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2ColonUpper")).withDescription("Turns the colon of the display on or off.").build();
            case "SegmentDisplay4x7V2ColonLower":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2ColonLower"), "Show Lower Colon Dot", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2ColonLower")).withDescription("Turns the colon of the display on or off.").build();
            case "SegmentDisplay4x7V2Tick":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Tick"), "Show Tick", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2Tick")).withDescription("Turns the colon of the display on or off.").build();
            case "SegmentDisplay4x7V2Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:SegmentDisplay4x7V2Text")).withDescription("Text to display on the seven segment display. Supported are A-Z, a-z, 0-9, \", (, ), +, -, =, [, ], ^, _ and |. An unsupported character will show as empty. A colon (:) anywhere in the text will light on the display's colon. Alternatively, you can enable only the upper colon dot with a backtick (`) or the lower one with a comma (,). An apostrophe (') anywhere will light up the tick after the third digit. A dot (.) after another character will light the corresponding digit's dot. For example H.i,T.'F will show HiTF on the display and activate the first and third dot, lower colon dot and the tick.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Segment Display 4x7 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Four 7-segment displays with switchable dots").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("SegmentDisplay4x7V2Brightness", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Brightness")).build(), new ChannelDefinitionBuilder("SegmentDisplay4x7V2ColonUpper", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2ColonUpper")).build(), new ChannelDefinitionBuilder("SegmentDisplay4x7V2ColonLower", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2ColonLower")).build(), new ChannelDefinitionBuilder("SegmentDisplay4x7V2Tick", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Tick")).build(), new ChannelDefinitionBuilder("SegmentDisplay4x7V2Segments", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Segments")).build(), new ChannelDefinitionBuilder("SegmentDisplay4x7V2Text", new ChannelTypeUID("tinkerforge", "SegmentDisplay4x7V2Text")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:segmentdisplay4x7v2":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:SegmentDisplay4x7V2Brightness":
                return new ConfigDescription(uri, Arrays.asList());
            case "channel-type:tinkerforge:SegmentDisplay4x7V2Segments":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:SegmentDisplay4x7V2ColonUpper":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:SegmentDisplay4x7V2ColonLower":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:SegmentDisplay4x7V2Tick":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:SegmentDisplay4x7V2Text":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletSegmentDisplay4x7V2Config cfg = (BrickletSegmentDisplay4x7V2Config) config.as(BrickletSegmentDisplay4x7V2Config.class);
        switch(value) {
            case "SegmentDisplay4x7V2Brightness": {
                   BrickletSegmentDisplay4x7V2BrightnessConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2BrightnessConfig.class);
                   updateStateFn.accept(value, transformSegmentDisplay4x7V2BrightnessGetter0(this.getBrightness(), cfg));
                   return;
               }
            case "SegmentDisplay4x7V2ColonUpper": {
                   BrickletSegmentDisplay4x7V2ColonUpperConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2ColonUpperConfig.class);
                   updateStateFn.accept(value, transformSegmentDisplay4x7V2ColonUpperGetter0(this.getSelectedSegment(32), cfg));
                   return;
               }
            case "SegmentDisplay4x7V2ColonLower": {
                   BrickletSegmentDisplay4x7V2ColonLowerConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2ColonLowerConfig.class);
                   updateStateFn.accept(value, transformSegmentDisplay4x7V2ColonLowerGetter0(this.getSelectedSegment(33), cfg));
                   return;
               }
            case "SegmentDisplay4x7V2Tick": {
                   BrickletSegmentDisplay4x7V2TickConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2TickConfig.class);
                   updateStateFn.accept(value, transformSegmentDisplay4x7V2TickGetter0(this.getSelectedSegment(34), cfg));
                   return;
               }
            case "SegmentDisplay4x7V2Segments": {
                   BrickletSegmentDisplay4x7V2SegmentsConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2SegmentsConfig.class);
                   updateStateFn.accept(value, transformSegmentDisplay4x7V2SegmentsGetter0(this.getSegments(), cfg));
                   return;
               }
            case "SegmentDisplay4x7V2Text":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletSegmentDisplay4x7V2Config cfg = (BrickletSegmentDisplay4x7V2Config) config.as(BrickletSegmentDisplay4x7V2Config.class);
        switch(channel) {
            case "SegmentDisplay4x7V2Brightness":
                if (command instanceof QuantityType) {
                    BrickletSegmentDisplay4x7V2BrightnessConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2BrightnessConfig.class);
                    QuantityType cmd = (QuantityType) command;
                    this.setBrightness(cmd.shortValue());
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a QuantityType.", command.getClass().getName(), channel);
                }
                break;
            case "SegmentDisplay4x7V2ColonUpper":
                if (command instanceof OnOffType) {
                    BrickletSegmentDisplay4x7V2ColonUpperConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2ColonUpperConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedSegment(32, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "SegmentDisplay4x7V2ColonLower":
                if (command instanceof OnOffType) {
                    BrickletSegmentDisplay4x7V2ColonLowerConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2ColonLowerConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedSegment(33, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "SegmentDisplay4x7V2Tick":
                if (command instanceof OnOffType) {
                    BrickletSegmentDisplay4x7V2TickConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2TickConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedSegment(34, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "SegmentDisplay4x7V2Segments":
                if (command instanceof QuantityType) {
                    BrickletSegmentDisplay4x7V2SegmentsConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2SegmentsConfig.class);
                    QuantityType cmd = (QuantityType) command;
                    this.setSegments(Helper.shortToBits((short)(cmd.intValue() >> 24)), Helper.shortToBits((short)(cmd.intValue() >> 16)), Helper.shortToBits((short)(cmd.intValue() >> 8)), Helper.shortToBits((short)cmd.intValue()), this.getSegments().colon, this.getSegments().tick);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a QuantityType.", command.getClass().getName(), channel);
                }
                break;
            case "SegmentDisplay4x7V2Text":
                if (command instanceof StringType) {
                    BrickletSegmentDisplay4x7V2TextConfig channelCfg = channelConfig.as(BrickletSegmentDisplay4x7V2TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.setSegments(Helper.parseSegmentDisplay2TextDigit(cmd.toString(), 0), Helper.parseSegmentDisplay2TextDigit(cmd.toString(), 1), Helper.parseSegmentDisplay2TextDigit(cmd.toString(), 2), Helper.parseSegmentDisplay2TextDigit(cmd.toString(), 3), new boolean[]{cmd.toString().contains("`") || cmd.toString().contains(":"), cmd.toString().contains(",") || cmd.toString().contains(":")}, cmd.toString().contains("'"));
                    result.add(new SetterRefresh("SegmentDisplay4x7V2Segments", 0));
				result.add(new SetterRefresh("SegmentDisplay4x7V2ColonUpper", 0));
				result.add(new SetterRefresh("SegmentDisplay4x7V2ColonLower", 0));
				result.add(new SetterRefresh("SegmentDisplay4x7V2Tick", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformSegmentDisplay4x7V2BrightnessGetter0(int value, BrickletSegmentDisplay4x7V2Config cfg) {
        return new QuantityType(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformSegmentDisplay4x7V2ColonUpperGetter0(boolean value, BrickletSegmentDisplay4x7V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformSegmentDisplay4x7V2ColonLowerGetter0(boolean value, BrickletSegmentDisplay4x7V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformSegmentDisplay4x7V2TickGetter0(boolean value, BrickletSegmentDisplay4x7V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformSegmentDisplay4x7V2SegmentsGetter0(Segments value, BrickletSegmentDisplay4x7V2Config cfg) {
        return new QuantityType((Helper.bitsToLong(value.digit0) << 24) | (Helper.bitsToLong(value.digit0) << 16) | (Helper.bitsToLong(value.digit0) << 8) | Helper.bitsToLong(value.digit0), SmartHomeUnits.ONE);
    }
}
